//
//  SKTArrowLine.m
//  Sketch BP
//
//  Created by OD  on Sat Jan 22 2005.
//  Copyright (c) 2005 __MyCompanyName__. All rights reserved.
//

#import "SKTArrowLine.h"
#import "SKTGraphicView.h"
#import "SKTPolygon.h"

//static float SKTArrowLine = 2.0;

// t̐`悷NX
@implementation SKTArrowLine

- (id)init{
	self = [super init];
	if(self){
		_direction = NoneDirection;
//		_transform = [[NSAffineTransform transform] retain];
	}
	return self;
}

-(void)dealloc{
//    [_transform release];
	[super dealloc];
}

-(id)copyWithZone:(NSZone*)zone{
	id newObj = [super copyWithZone:zone];
	[newObj setDirection:_direction];
	[newObj setLineArrowMode:[super lineArrowMode]];
//	[newObj setTransform:_transform];
	return newObj;
}

-(void)setDirection:(int)dir{
	_direction = dir;
}
	
-(int) direction{
	return _direction;
}

/*
- (void)setTransform:(NSAffineTransform*)transform {
    [_transform release];
    _transform = [transform retain];
}
*/

/*
- (NSAffineTransform*)transform {
    return _transform;
}
*/

-(void) flipHorizontally{
	_direction *= -1;
}

-(void)flipVertically{
	if(abs(_direction) == 1){
		_direction *= 2;
	}else{
		_direction /= 2;
	}
	return;
}

-(BOOL) drawsFill{
	// Lines never draw fill
	return false;
}

-(BOOL) canDrawFill{
	// Lines never draw fill
	return false;
}

-(BOOL)hasNaturalSize{
	// Lines have no "natural" size
	return false;
}

-(BOOL)hasLineArrowMode{
	return true;
}

-(NSBezierPath *) bezierPath{

	NSBezierPath* path = [NSBezierPath bezierPath];
	NSRect bounds = [self bounds];
	
	NSPoint fromPt, toPt;
	fromPt = toPt = NSZeroPoint;
	
	if ([self isCreating]) {
		_direction = [self directionOfCreating];
	}
	
//	fprintf(stderr, "direction = %d\n", _direction);
	
	switch (_direction) {
		case UpperRightDirection:{
			fromPt.x = bounds.origin.x;
			fromPt.y = bounds.origin.y + bounds.size.height;
			toPt.x = bounds.origin.x + bounds.size.width;
			toPt.y = bounds.origin.y;
			break;
			}
		case LowerRightDirection:{
			fromPt.x = bounds.origin.x;
			fromPt.y = bounds.origin.y;
			toPt.x = bounds.origin.x + bounds.size.width;
			toPt.y = bounds.origin.y + bounds.size.height;
			break;
			}
		case UpperLeftDirection:{
			fromPt.x = bounds.origin.x + bounds.size.width;
			fromPt.y = bounds.origin.y + bounds.size.height;
			toPt.x = bounds.origin.x;
			toPt.y = bounds.origin.y;
			break;
			}
		case LowerLeftDirection:{
			fromPt.x = bounds.origin.x + bounds.size.width;
			fromPt.y = bounds.origin.y;
			toPt.x = bounds.origin.x;
			toPt.y = bounds.origin.y + bounds.size.height;
			break;
			}
		default:{
			return nil;
		}
	}
	
	[path moveToPoint:fromPt];
	[path lineToPoint:toPt];
	
	NSPoint arrowRight, arrowLeft;

	if([self lineArrowMode] != ARROWMODE_NONE){
		double r = atan2(toPt.y - fromPt.y, toPt.x - fromPt.x);
		NSAffineTransform* _transform = [NSAffineTransform transform];
		[_transform rotateByRadians:r];

		if([self lineArrowMode] == ARROWMODE_END || [self lineArrowMode] == ARROWMODE_BOTH){
			arrowRight = [_transform transformPoint:NSMakePoint(-9*[self strokeLineWidth], -5*[self strokeLineWidth])];
			arrowLeft = [_transform transformPoint:NSMakePoint(-9*[self strokeLineWidth], 5*[self strokeLineWidth])];
			[path moveToPoint:NSMakePoint(arrowRight.x + toPt.x, arrowRight.y + toPt.y)];
			[path lineToPoint:toPt];
			[path lineToPoint:NSMakePoint(arrowLeft.x + toPt.x, arrowLeft.y + toPt.y)];
//			[path moveToPoint:NSMakePoint(arrowLeft.x + toPt.x, arrowLeft.y + toPt.y)];
//			[path lineToPoint:toPt];
		}
		if([self lineArrowMode] == ARROWMODE_START || [self lineArrowMode] == ARROWMODE_BOTH){
			arrowRight = [_transform transformPoint:NSMakePoint(9*[self strokeLineWidth], -5*[self strokeLineWidth])];
			arrowLeft = [_transform transformPoint:NSMakePoint(9*[self strokeLineWidth], 5*[self strokeLineWidth])];
			[path moveToPoint:fromPt];
			[path lineToPoint:toPt];
			[path moveToPoint:NSMakePoint(arrowRight.x + fromPt.x, arrowRight.y + fromPt.y)];
			[path lineToPoint:fromPt];
			[path lineToPoint:NSMakePoint(arrowLeft.x + fromPt.x, arrowLeft.y + fromPt.y)];
		}
//		[_transform release];
	}
	
//	if([self lineDashFlag]){
//		float dasharray[2] = {[self lineDashSpace], [self lineDashSpace]};
//		[path setLineDash: dasharray count: 2 phase: 0.0];
//	}

	[path setLineWidth:[self strokeLineWidth]];
	
	return path;
}

-(int)knobMask{
	if (_direction == LowerLeftDirection || _direction == UpperRightDirection) {
		return (LowerLeftKnobMask | UpperRightKnobMask);
	} else {
		return (UpperLeftKnobMask | LowerRightKnobMask);
	}
}

-(BOOL) startsAtLowerLeft{
	return (_direction == LowerLeftDirection || _direction == UpperRightDirection);
}



-(BOOL) hitTest:(NSPoint)point isSelected:(BOOL)isSelected {
//	fprintf(stderr, "call hittest.\n");
    if (isSelected && ([self knobUnderPoint:point] != NoKnob)) {
		return YES;
	}
    if (isSelected && ([self knobUnderPoint:point] != NoKnob)) {
		return YES;
	} else {
		NSRect bounds = [self bounds];
		float halfWidth = [self strokeLineWidth] / 2.0;
		halfWidth += 2.0;  // Fudge
		if (bounds.size.width == 0.0) {
			if (fabs(point.x - bounds.origin.x) <= halfWidth) {
				return YES;
			}
		} else {
			BOOL startsAtLowerLeft = [self startsAtLowerLeft];
			float slope = bounds.size.height / bounds.size.width;
			
			if (startsAtLowerLeft) {
				slope = -slope;
			}
			
            if (fabs(((point.x - bounds.origin.x) * slope) - (point.y - (startsAtLowerLeft ? NSMaxY(bounds) : bounds.origin.y))) <= halfWidth) {
				return YES;
			}
		}
		return NO;
	}
}


NSString *LineDirection = @"LineDirection";
NSString *ArrowMode = @"ArrowMode";

-(NSMutableDictionary*) propertyListRepresentation{
	NSMutableDictionary *dict = [super propertyListRepresentation];
	[dict setObject:[NSNumber numberWithInt:[self lineArrowMode]] forKey:ArrowMode];
	[dict setObject:[NSNumber numberWithInt:_direction] forKey:LineDirection];
	return dict;
}

-(void)loadPropertyListRepresentation :(NSDictionary*)dict{
	id obj;
	
	[super loadPropertyListRepresentation:dict];
	
	obj = [dict objectForKey:LineDirection];
	if (obj){
		[self setDirection:[obj intValue]];
	}
	
	obj = [dict objectForKey:ArrowMode];
	if (obj){
		[self setLineArrowMode:[obj intValue]];
	}
}

@end
