//
// SKTPolygon.h
// By mkino
//

#import <Cocoa/Cocoa.h>
#import "SKTGraphic.h"

@interface SKTPolygon : SKTGraphic {
    @private
    NSMutableArray*		_anchorPoints;
    BOOL				_isPathClosed;
    
    NSAffineTransform*	_transform;
    BOOL				_isFlippedVertically;
    BOOL				_isFlippedHorizontally;
    int					_selectedPointIndex;
}

//
// Accessors
//

- (void)setAnchorPoints:(NSArray*)anchorPoints;
- (NSArray*)anchorPoints;
- (void)setPathClosed:(BOOL)isPathClosed;
- (BOOL)isPathClosed;
- (void)setTransform:(NSAffineTransform*)transform;
- (NSAffineTransform*)transform;

//
// Anchor points management
//

- (int)indexOfPoint:(NSPoint)point;
- (NSPoint)pointAtIndex:(int)index;
- (void)appendPoint:(NSPoint)point;
- (void)movePointAtIndex:(int)index toPoint:(NSPoint)point;
- (void)removePointAtIndex:(int)index;

//
// Drawing
//

- (NSBezierPath*)origBezierPath;
- (void)drawAnchorHandlesInView:(SKTGraphicView*)view;

//
// Polygon specific
//

- (int)anchorPointUnderPoint:(NSPoint)point;
- (void)applyTransform;

@end
