#!/bin/sh
# This shell-script build phase happens only when installing and causes the 
# project sources (which are shipped as an example) to be installed.

EXAMPLESDIR=${SYSTEM_DEVELOPER_DIR}/Examples/AppKit

# install the source
pbxbuild installsrc "SYMROOT=${SYMROOT}" "OBJROOT=${OBJROOT}" "DSTROOT=${DSTROOT}" "SRCROOT=${DSTROOT}${EXAMPLESDIR}/${PRODUCT_NAME}"

# strip out garbage
find ${DSTROOT}${EXAMPLESDIR}/${PRODUCT_NAME} -name "*~" -exec rm -rf {} \; -prune ; 
find ${DSTROOT}${EXAMPLESDIR}/${PRODUCT_NAME} -type d -name "CVS" -exec rm -rf {} \; -prune ;
find ${DSTROOT}${EXAMPLESDIR}/${PRODUCT_NAME} -name "*.pbxuser" -exec rm -rf {} \; ;
rm -rf ${DSTROOT}${EXAMPLESDIR}/${PRODUCT_NAME}/build

# set permissions
chmod -R u+rwX,go+rX,go-w ${DSTROOT}${EXAMPLESDIR}/${PRODUCT_NAME}

if [ z"WINDOWS" != z"${OS}" ] ; then
    chown -R ${INSTALL_OWNER}.${INSTALL_GROUP} ${DSTROOT}${EXAMPLESDIR}/${PRODUCT_NAME}
fi

